<?php
function k_readability_main_settings(){
	echo(__("The main settings",LOCALE_DOMAIN));
}

function k_readability_post_settings(){
	echo(__("The post settings",LOCALE_DOMAIN));
}

function k_readability_title(){
	$options = get_option('readability_options');
	?>
	<input id="k_readability_title" name="readability_options[title]" value="<?php echo (isset($options['title']))?$options['title']: ""; ?>"/>
	<p><em><?php _e("start date:", LOCALE_DOMAIN) ?></em> ###start###</p>
	<p><em><?php _e("end date:", LOCALE_DOMAIN) ?></em> ###end###</p>
	<p>e.g.: <strong><?php echo(date_i18n(get_option('date_format'), time())) ?></strong> </p>
	<?php
}

function k_readability_pre(){
	$options = get_option('readability_options');
	?>
	<textarea id="k_readability_pre" name="readability_options[pre]"><?php echo $options['pre'];?></textarea>
	<?php 
}

function k_readability_schedule(){
	$options = get_option('readability_options');
	$link = "http://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF']."?page={$_GET['page']}";
	?>
	<select id="k_readability_schedule" name="readability_options[schedule]">
		<option <?php if($options['schedule'] == 'daily') echo('selected'); ?> value="daily"><?php _e("daily",LOCALE_DOMAIN); ?></option>
		<option <?php if($options['schedule'] == 'weekly') echo('selected'); ?> value="weekly"><?php _e("weekly",LOCALE_DOMAIN); ?></option>
		<option <?php if($options['schedule'] == 'manually') echo('selected'); ?> value="manually"><?php _e("manually",LOCALE_DOMAIN); ?></option>
	</select>
	<p><?php _e("To trigger the plugin manually use the following Link (e.g. external cronjob):",LOCALE_DOMAIN); ?></p>
	<p><?php echo "<a href='{$link}&manual=manually'>{$link}&manual=manually</a>"; ?></p>
	<?php
}

function k_readability_category() {
	$options = get_option('readability_options');
	$cats = get_categories();
	?>
	<select id="k_readability_category" name="readability_options[category]">
	<?php
		foreach ($cats as $cat) {
			echo "<option value='{$cat->cat_ID}'";
			if($options['category'] == $cat->cat_ID)
				echo 'selected';
			
			echo ">{$cat->name}</option>";
		}
	?>
	</select>
	<?php
}

function k_readability_status() {
	//'draft' | 'publish' | 'pending'
	$options = get_option('readability_options');
	?>
	<select id="k_readability_status" name="readability_options[status]">
		<option <?php if($options['status'] == 'draft') echo('selected'); ?>>draft</option>
		<option <?php if($options['status'] == 'publish') echo('selected'); ?>>publish</option>
		<option <?php if($options['status'] == 'pending') echo('selected'); ?>>pending</option>
	</select>
	<?php
}

function k_readability_hint() {
	$options = get_option('readability_options');
	if($options['hint'] == 'hint'){
		$checked = "checked";
	}else {
		$checked = "";
	}
	?>
	<input type="checkbox" name="readability_options[hint]" value="hint" <?php echo($checked); ?>/>
	<?php 
}

function k_readability_show_preview() {
	$options = get_option('readability_options');
	if($options['show_preview'] == 'show_preview'){
		$checked = "checked";
	}else {
		$checked = "";
	}
	?>
	<input type="checkbox" name="readability_options[show_preview]" value="show_preview" <?php echo($checked); ?>/>
	<?php 
}


function k_readability_connect() {
	$options = get_option('readability_options');
	$consumer = new OAuthConsumer(consumer_key, consumer_secret, NULL);
	$endpoint = "https://www.readability.com/api/rest/v1/oauth/authorize/";
	$req = OAuthRequest::from_consumer_and_token($consumer, NULL, "GET",$endpoint, array("oauth_callback" => "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']));
	$req->sign_request(new OAuthSignatureMethod_HMAC_SHA1(), $consumer, NULL);
		
	
	if(isset($_GET['oauth_callback_confirmed']) &&$_GET['oauth_callback_confirmed'] && !$options['oauth_token']){
		//Authorization was good
		$consumer = new OAuthConsumer(consumer_key, consumer_secret, NULL);
		$endpoint = "https://www.readability.com/api/rest/v1/oauth/request_token/";
		$req = OAuthRequest::from_consumer_and_token($consumer, NULL, "GET",$endpoint, $_REQUEST);
		$req->sign_request(new OAuthSignatureMethod_HMAC_SHA1(), $consumer, NULL);
		//print_r($req);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $req->to_url());
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec($ch);
		$parsed_result = array();
		curl_close($ch);
		$tmp = explode("&",$result);
		foreach($tmp as $part){
			$tmp2 = explode("=", $part);
			if(count($tmp2) == 2){
				$parsed_result[$tmp2[0]] = $tmp2[1];	
			}
		}
		//var_dump(($parsed_result));
		$token2 = new OAuthToken($parsed_result['oauth_token'], $parsed_result['oauth_token_secret']);
		$endpoint2 = "https://www.readability.com/api/rest/v1/oauth/access_token/";
		$req = OAuthRequest::from_consumer_and_token($consumer, $token2, "GET",$endpoint2, array('oauth_verifier' => $parsed_result['oauth_verifier']));
		$req->sign_request(new OAuthSignatureMethod_HMAC_SHA1(), $consumer, $token2);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $req->to_url());
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$result = curl_exec($ch);
		curl_close($ch);
		
		
		$parsed_result = array();
		$tmp = explode("&",$result);
		foreach($tmp as $part){
			$tmp2 = explode("=", $part);
			if(count($tmp2) == 2){
				$parsed_result[$tmp2[0]] = $tmp2[1];	
			}
		}
		$options['oauth_token'] = $parsed_result['oauth_token'];
		$options['oauth_token_secret'] = $parsed_result['oauth_token_secret'];
		update_option('readability_options', $options);
	}
	
	if(!isset($options['oauth_token']) || $options['oauth_token'] == false){ 
	echo '<a href="'.$req.'" title="Authorize Plugin with readability">'.__("Authorize with Readability", LOCALE_DOMAIN).'</a>';
	}else{ 
	 echo __('Authorized',LOCALE_DOMAIN);
	}
	
}

function k_readability_featured_image() {
	$options = get_option('readability_options');
	?>
	<script type="text/javascript">
	jQuery(document).ready(function() {
	
	jQuery('#upload_image_button').click(function() {
	 formfield = jQuery('#upload_image').attr('name');
	 tb_show('', 'media-upload.php?post_id=0&amp;type=image&amp;TB_iframe=true');
	 return false;
	});
	
	window.send_to_editor = function(html) {
	console.log(html);
	 imgurl = jQuery('img',html).attr('src');
	 jQuery('#upload_image').val(imgurl);
	 jQuery('#k_readability_featured_image').attr('src', imgurl);
	 tb_remove();
	}
	
	});
	</script>
	<p><img src="<?php echo (isset($options['featured_image']))?$options['featured_image']: ""; ?>" alt="featured_image" id="k_readability_featured_image"/></p>
	<input id="upload_image" type="text" size="36" name="readability_options[featured_image]" value="<?php echo (isset($options['featured_image']))?$options['featured_image']: ""; ?>" />
	<input id="upload_image_button" type="button" value="Upload Image" />
	<br />Enter an URL or upload an image for the banner.
	
	<?php 
}

function k_readability_preview(){
	$options = get_option('readability_options');
	if($options['show_preview'] != "show_preview"){
		return;
	}
	$last = get_option('readability_last_executed', false);
	$start = $last;
	if($last == false){
		$start = mktime(0,0,0,0,0,0);
	}
	
	$end = time();
	$results = k_get_posts_from_readability($start, $end);
	echo "<h2>Preview</h2>";
	echo "<p>"._e("This post will be published at", LOCALE_DOMAIN)." <strong>".date_i18n(get_option('date_format'),wp_next_scheduled('k_readability_favorite_hook'))."</strong></p>";
	echo "<div id='k_readability_preview' style='margin:0 10px;border:1px solid #585858; padding:10px;'>";
	echo "<h3>".k_readability_generate_title($start, $end)."</h3>";
	echo k_readability_generate_post($results);
	echo "<div>";
}
?>